// Basic Patcher, Carwyn Jones ©(2002)

#include <fstream>
#include <string.h>

int FilePatch(const char *file);

int main(int argc, char *argv[])
{
	if(argc != 2) {
		cout << argv[0] << " <file to patch>" << endl;
		return(true);
	}
	FilePatch(argv[1]);
	return(0);
}

int FilePatch(const char *file)
{
	fstream fin;
	char buf[13];
	char rbuf[256];
	unsigned long j;
	unsigned long i = 0;
	bool found = false;
	char c;
	char origid[] = "GenuineIntel";
	char newid[] = "AuthenticAMD";
	char finder[] = "Started only";
	
	fin.open(file, ios::in | ios::out | ios::binary);
	if(!fin) {
		cout << "Can't open: " << file << " for reading" << endl;
		return(true);
	}
	
	fin.seekg(0, ios::end);
	j = fin.tellg();
	fin.seekg(ios::beg);
	
	cout << "Now trying to patch your BeOS PE image, please be patient it may take a while" << endl;
	cout.setf(ios::showbase);
	
	while(!fin.eof()) { // ooh what a mess, eh!
		fin.get(c);
		if(c == 'S') {
			fin.seekg(fin.tellg()-1);
			fin.read(buf, 12);
			if(strncmp(finder, buf, 12) == 0) {
				i = fin.tellg();
				fin.read(rbuf, 128);
				for(int k = 0; k < 127; k++) {
					if(rbuf[k] == 'G') {
						found = true;
						i += k;
						cout << origid << " :was found at the following locations :" << hex << i << endl;
						fin.seekg(i);
						fin.write(newid, 12);
					}
				}
			}
		}
	}
	
	if(found) cout << "The patch seems to have been successful, please try your BeOS PE image\n";
		else cout << "The patch has failed, or the file has already been patched\n";

	fin.close();
	return(0);
}